    var DONEPAGE = "donePage.html";
    var panelStack = new Array();
    panelStack.push( DONEPAGE );

    //Stack of group elements (sequences)
    //Items are not popped instead they are accessed with the grpSeqStackPos
    var grpSeqStack = new Array();
    //Position of the current group element sequence
    var grpSeqStackPos = 0;
    //stack of arrays containing { location of calling sequence in panel stack, sequenceNameToSubsequence key}
    var newSeqStack = new Array();
    //Stack of where previous group had left off.  Only used in a group enviroment
    var grpElementStack = new Array();
    //which group am I currently in.
    var currentGroup;
    // group name to sequence array map
    var grpToSeqsMap = {
        set : function( grp, seqs ) { this[grp] = seqs;},
        get : function( grp ) { return this[grp];}
    };
    //Maps sequence:subsequenceName to it's possible navigation structure upon return
    var seqSubSeqToNavLink = {
        set : function( grp, seqs ) { this[grp] = seqs;},
        get : function( grp ) { return this[grp];}
    };
    //Maps sequence:subSequenceName to it's last viewed panel for subsequence.last
    var subSequenceLastPanel = {
        set : function( key, value ) { this[key] = value;},
        get : function( key ) { return this[key];}
    };

    var homePath = "../";

    //WRITEINITIALPANELSHERE

    //WRITEGROUPSEQUENCESHERE

    //WRITESUBNAVLINKSHERE

    function startGrpSeq( grpOrSeq ){
        trace( "startGrpSeq('" + grpOrSeq + "')");
        grpSeqStack = new Array();
        panelStack = new Array();
        panelStack.push( DONEPAGE );
        var subSequenceLastPanel = {
            set : function( key, value ) { this[key] = value;},
            get : function( key ) { return this[key];}
        };
        if( grpToSeqsMap && grpToSeqsMap.get( grpOrSeq )){
            startGroup( grpOrSeq );
        } else {
            startSequence( grpOrSeq );
        }
    }

    function startGroup( group ){
        trace( "startGroup('" + group + "')");
        grpElementStack = new Array();
        grpSeqStackPos = 0;
        //alert( grpToSeqsMap.get( group ) );
        currentGroup = group;
        //get first sequence
        var initSeqAry = grpToSeqsMap.get( group );
        if( initSeqAry ){
            // add the group's sequences to the group Sequence stack
            for( i =(initSeqAry.length-1) ; i >= 0; i--){
                if( getInitial( initSeqAry[i] ))
                    grpSeqStack.push( getInitial( initSeqAry[i] ));
            }
            grpSeqStackPos = grpSeqStack.length-1;
            parent.panelFrame.location = grpSeqStack[grpSeqStackPos];
        } else {
            alert("There was an error locating this group.");
        }
    }

    function startSequence( sequence ){
        trace( "startSequence('" + sequence + "')");
        currentGroup = "";

        startSeqPan = getInitial( sequence );
        if( startSeqPan ){
            parent.panelFrame.location = startSeqPan;
        } else {
            alert("There was an error starting the sequence: " + sequence + ". Unable to find initial panel." );
        }
    }

    function myOPEN( caller, panel ){
        trace( "myOPEN('" + caller + "','" + panel + "')");
        panelStack.push( caller );
        parent.panelFrame.location = homePath + panel ;
        isLoadedPan( panel );
    }

    function myCLOSE( caller ){
        trace( "myCLOSE('" + caller + "')");
        if( currentGroup ){
            var prevGrpElementLoc = grpElementStack[ grpElementStack.length -1 ];
            if( prevGrpElementLoc && panelStack.length - 1 == prevGrpElementLoc ){
                myCOMPLETE( caller );
                return;
            }
        }
        popped = panelStack.pop();
        if( popped != undefined ){
            var prevSubSeq = newSeqStack.pop();
            //if we closed and this was the last panel in the subSequence, remove the
            //panel stack array reference
            if( prevSubSeq && prevSubSeq[0] < panelStack.length ){
                newSeqStack.push( prevSubSeq );
            } else if( prevSubSeq && prevSubSeq[0] == panelStack.length ){
                //return everything
                panelStack.push( popped );
                newSeqStack.push( prevSubSeq );
                //pretend as if this last close did a complete (easier that way);
                myCOMPLETE( caller );
                return;
            }
            parent.panelFrame.location = homePath + popped ;
        } else {
            newSeqStack = new Array();
            parent.panelFrame.location = homePath + "donePage.html";
        }
    }
    function myCOMPLETE( callerSequence ){
        trace( "myCOMPLETE('" + callerSequence + "')");
    	var panel;
        // go back to the previous sequence (if there is one)
        var prevSub = newSeqStack.pop();
        do {
            panel = panelStack.pop();	
        } while( prevSub && panelStack.length > prevSub[0] );

        //we are a group element (not a subsequence of one)
        if( currentGroup && !prevSub){
            panelStack.push( panel );
            panelStack.push( callerSequence );
            grpElementStack.push( panelStack.length -1 );
            grpSeqStackPos--;
            if( grpSeqStackPos >= 0 ){
                panel = grpSeqStack[grpSeqStackPos];
            } else {
                panel = DONEPAGE;
            }
            parent.panelFrame.location = homePath + panel;
            return;
        } else {
            //Regular sequence
            if( !panel ){
                panel = DONEPAGE;
            }
        }

        //were we in a subsequence?
        if( prevSub ){
            //make this panel the last in this subsequence
            subSequenceLastPanel.set( prevSub[2], callerSequence );
            //get the navigation structure for this sequences + subsequence name

            var subNavLink = seqSubSeqToNavLink.get( prevSub[1] );
            if( subNavLink ){
                var typeTargAry = subNavLink.getLink( 'COMPLETE' );
                switch ( typeTargAry[0] ) {
                case "COMPLETE":
                    myCOMPLETE( panel );
                    break;
                case "OPEN":
                    myOPEN( panel, typeTargAry[1] );
                    break;
                case "REPLACE":
                    myREPLACE( typeTargAry[1] );
                    break;
                case "CLOSE":
                    myCLOSE();
                    break;
                case "BACK_COMPLETE":
                    myBACK_COMPLETE( panel );
                    break;
                default:
                    alert("There was an error locating the previous subSequence");
                    parent.panelFrame.location = homePath + DONEPAGE;
                    break;
                }
            }

        } else {
            if( currentGroup ){
                parent.panelFrame.location = homePath + panel;
            } else {
                parent.panelFrame.location = homePath + DONEPAGE;
            }

        }
    }

    function myBACK_COMPLETE( callerSequence ){
        trace( "myBACK_COMPLETE('" + callerSequence + "')");
        var panel;
        // go back to the previous sequence (if there is one)
        var prevSub = newSeqStack.pop();
        do {
            panel = panelStack.pop();	
        } while( prevSub && panelStack.length > prevSub[0] );

        //we are a group element (not a subsequence of one)
        //backup to where previous subsequence completed
        if( currentGroup && !prevSub){
            var prevGroupElement = grpElementStack.pop();
            //go back to the previous group that last completed
            while( panelStack.length -1 >= prevGroupElement ){
                panel = panelStack.pop();
            }
            grpSeqStackPos++;
            if( grpSeqStackPos < 0 || grpSeqStackPos >= grpSeqStack.length ){
                panel = DONEPAGE;
            }
            parent.panelFrame.location = homePath + panel;
            return;
        } else {
            //Regular sequence
            if( !panel ){
                panel = DONEPAGE;
            }
        }

        //were we in a subsequence?
        if( prevSub ){
            //make this panel the last in this subsequence
            subSequenceLastPanel.set( prevSub[2], callerSequence );
            //get the navigation structure for this sequences + subsequence name

            var subNavLink = seqSubSeqToNavLink.get( prevSub[1] );
            if( subNavLink ){
                var typeTargAry = subNavLink.getLink( 'BACK_COMPLETE' );
                switch ( typeTargAry[0] ) {
                case "COMPLETE":
                    myCOMPLETE( panel );
                    break;
                case "OPEN":
                    myOPEN( panel, typeTargAry[1] );
                    break;
                case "REPLACE":
                    myREPLACE( typeTargAry[1] );
                    break;
                case "CLOSE":
                    myCLOSE();
                    break;
                case "BACK_COMPLETE":
                    myBACK_COMPLETE( panel );
                    break;
                default:
                    alert("There was an error locating the previous subSequence");
                    parent.panelFrame.location = homePath + DONEPAGE;
                    break;
                }
            }
        } else {
            if( currentGroup ){
                parent.panelFrame.location = homePath + panel;
            } else {
                parent.panelFrame.location = homePath + DONEPAGE;
            }
        }
    }

    function myREPLACE( panel ){
        trace( "myREPLACE('" + panel + "')");
        parent.panelFrame.location = homePath + panel ;
        isLoadedPan( panel );
    }	

    function mySUSPEND( panel ){
        trace( "mySUSPEND('" + panel + "')");
        alert( "Sequence suspended target: " + panel );
    }

    function mySUBSEQUENCE( callingSubsequence, callingPanel, targetName, isDotLast, subsequence, type ){
        trace( "mySUBSEQUENCE('" + callingSubsequence + "','" + callingPanel + "','" + targetName + "," + isDotLast + ",'" + subsequence  + "','" + type + "')");
        if( getInitial( subsequence )){
            if( isDotLast ){
                var lastPanelInSS = subSequenceLastPanel.get( subsequence + ":" + targetName )
            }
            switch( type ){
            case "REPLACE":
                newSeqStack.push( new Array(panelStack.length-1, callingSubsequence + ":" + targetName, subsequence + ":" + targetName) );
                if( lastPanelInSS ){
                    myREPLACE( lastPanelInSS );
                } else {
                    myREPLACE( getInitial( subsequence ));
                }

                break;
            case "OPEN":
                newSeqStack.push( new Array(panelStack.length, callingSubsequence + ":" + targetName, subsequence + ":" + targetName) );
                if( lastPanelInSS ){
                    myOPEN( callingSubsequence + "/" + callingPanel, lastPanelInSS);
                } else {
                    myOPEN( callingSubsequence + "/" + callingPanel, getInitial( subsequence ));
                }

                break;
            }
        } else {
            alert("There was an error starting the subsequence: " + subsequence + ". Unable to find initial panel." );
        }
    }

    function printStack(){
        var testDivOne = parent.dataFrame.document.getElementById( "TESTAREA1" );
        if( testDivOne ){
            if( testDivOne.firstChild ){
                testDivOne.removeChild( testDivOne.firstChild );
            }

            //if( panelStack.length > 0 ){
                var div = document.createElement('div');

                var aDiv = document.createElement('div');
                aDiv.appendChild( document.createTextNode( "panelStack" ) );
                div.appendChild( aDiv );

                for( i =panelStack.length-1; i >= 0;i--){
                    var aDiv = document.createElement('div');
                    aDiv.appendChild( document.createTextNode( i + " " + panelStack[i] ));
                    div.appendChild( aDiv );
                }
                var aDiv = document.createElement('div');
                aDiv.appendChild( document.createTextNode( "\x0a" ) );
                div.appendChild( aDiv );

                var aDiv = document.createElement('div');
                aDiv.appendChild( document.createTextNode( "newSeqStack" ) );
                div.appendChild( aDiv );

                for( j=newSeqStack.length-1; j >=0 ;j--){
                    var aDiv = document.createElement('div');
                    aDiv.appendChild( document.createTextNode( j + " " + newSeqStack[j] ));
                    div.appendChild( aDiv );
                }
                var aDiv = document.createElement('div');
                aDiv.appendChild( document.createTextNode( "\x0a" ) );
                div.appendChild( aDiv );

                var aDiv = document.createElement('div');
                aDiv.appendChild( document.createTextNode( "grpSeqStackPos " + grpSeqStackPos ) );
                div.appendChild( aDiv );

                var aDiv = document.createElement('div');
                aDiv.appendChild( document.createTextNode( "grpSeqStack" ) );
                div.appendChild( aDiv );

                for( j=grpSeqStack.length -1; j>=0;j--){
                    var aDiv = document.createElement('div');
                    aDiv.appendChild( document.createTextNode( j + " " + grpSeqStack[j] ));
                    div.appendChild( aDiv );
                }

                var aDiv = document.createElement('div');
                aDiv.appendChild( document.createTextNode( "\x0a" ) );
                div.appendChild( aDiv );

                var aDiv = document.createElement('div');
                aDiv.appendChild( document.createTextNode( "grpElementStack" ) );
                div.appendChild( aDiv );

                for( j=grpElementStack.length-1; j>=0;j--){
                    var aDiv = document.createElement('div');
                    aDiv.appendChild( document.createTextNode( j + " " + grpElementStack[j] ));
                    div.appendChild( aDiv );
                }
                var aDiv = document.createElement('div');
                aDiv.appendChild( document.createTextNode( "\x0a" ) );
                div.appendChild( aDiv );

                var aDiv = document.createElement('div');
                aDiv.appendChild( document.createTextNode( "subSequenceLastPanel" ) );
                div.appendChild( aDiv );

                var defCount =0;
                for( j in subSequenceLastPanel ){
                    if( defCount > 1 ){
                        var aDiv = document.createElement('div');
                        aDiv.appendChild( document.createTextNode( j + " " + subSequenceLastPanel[j] ));
                        div.appendChild( aDiv );
                    }
                    defCount++;
                }

                testDivOne.appendChild( div );
            //}
        }
    }

    function trace( msg ){
        var testDivTwo = parent.dataFrame.document.getElementById( "TRACE" );
        if( testDivTwo ){
            var div = document.createElement('div');
            var aDiv = document.createElement('div');
            aDiv.appendChild( document.createTextNode( msg ) );
            div.appendChild( aDiv );
            testDivTwo.appendChild( div );
        }
    }

	function isLoadedPan( panel ){
        var count = 0;
        var sameSeq = true;
        var firstCurrentSequence = 0;
        //if there are previous groups on the panel stack, stop before we get to the previous
        if( grpElementStack.length > 0 ){
            firstCurrentSequence = grpElementStack[ grpElementStack.length-1];
        }
        //if there are previous subsequences loaded stop before getting to them
        if( newSeqStack.length > 0 ){
            firstCurrentSequence = newSeqStack[newSeqStack.length-1][0];
        }
        //loop through panel stack, if this panel is loaded output error
        for( x = panelStack.length-1; x >= firstCurrentSequence; x--){
            if( panelStack[x] == panel){
                count++;				
            }
        }
		if( count == 1 ){
			alert("Loop detected. You are about to go to panel: '" + panel.split('/')[1].split('.')[0] + "' which has already been loaded within the current sequence: '" + panel.split('/')[0] +"'." );
		}
		if( count > 1 ){
			alert("Loop detected. You are about to go to panel: '" + panel.split('/')[1].split('.')[0] + "' which has already been loaded "+ count + " times within the current sequence: '" + panel.split('/')[0] +"'." );
		}

	}
	function isLoadedSeq( panel, sequence ){
        panelSequenceAry = panel.split('/');
        callerSequence = panelSequenceAry[0];
        var count = 0;
        var countSeq = 0;
        var sameSeq = true;
        var seqToCheck = true;
        for( x = panelStack.length-2; x >= 0; x--){
            panelStackSeqAry = panelStack[x].split('/');
            panelStackSeq = panelStackSeqAry[0];
            if( panelStackSeq != callerSequence ){
                sameSeq = false;
            }

            //same sequence
            if( seqToCheck && panelStackSeq == sequence ){
                countSeq++;
                seqToCheck = false;
            } else if( panelStackSeq != sequence ){
                seqToCheck = true;
            }
            if( sameSeq && panelStack[x] == panel){
                count++;				
            }
        }
        if( countSeq == 1){
            alert("Loop detected.  You are about to go to sequence: '" + sequence + "' which has already been loaded.");
        }
        if( countSeq > 1){
            alert("Loop detected.  You are about to go to sequence: '" + sequence + "' which has already been loaded " + countSeq + " times.");
        }

        if( count == 1 ){
			alert("Loop detected upon returning from new sequence: '" + sequence + "'. You are to return to panel: '" + panelSequenceAry[1].split('.')[0] + "' which has already been loaded within the current sequence: '" + panelSequenceAry[0] +"'." );
		}
		if( count > 1 ){
			alert("Loop detected upon returning from new sequence: '" + sequence + "'. You are to return to panel: '" + panelSequenceAry[1].split('.')[0] + "' which has already been loaded "+ count + " times within the current sequence: '" + panelSequenceAry[0] +"'." );
		}

	}

    function checkSequence( sequence ){
        var countSeq = 0;
        var seqToCheck = true;
        for( x = panelStack.length-1; x >= 0; x--){
            panelStackSeqAry = panelStack[x].split('/');
            panelStackSeq = panelStackSeqAry[0];

            if( seqToCheck && panelStackSeq == sequence ){
                countSeq++;
                seqToCheck = false;
            } else if( panelStackSeq != sequence ){
                seqToCheck = true;
            }
        }
        if( countSeq == 1){
            alert("Loop detected.  You are about to go to sequence: '" + sequence + "' which has already been loaded.");
        }
        if( countSeq > 1){
            alert("Loop detected.  You are about to go to sequence: '" + sequence + "' which has already been loaded " + countSeq + " times.");
        }
    }

    function getInitial( panel ){
        var panelArray = initialPanels.split("|");
        for (x in panelArray) {
            var seqEntry = panelArray[x].split(":");
            if( seqEntry[0] == panel ){
                return panel + '/' + seqEntry[1];
            }
        }
    }
    function noClick(){
        alert("Please use the navigation below");
    }	

    function toggleSequenceBoxExpansion( prefix ){
        var sel = parent.panelFrame.document.getElementById(prefix + '_seqBox');
        if (sel.style.display == 'none' || sel.style.display == '' ) {
            handleExpand(prefix);
        } else {
            handleCollapse( prefix );
        }
    }
    function handleCollapse(prefix) {
        var el = parent.panelFrame.document.getElementById( prefix + '_seqBox');
        el.style.display = 'none';
        var twistie = parent.panelFrame.document.getElementById( prefix + '_twistie');
        twistie.src = "images/twistie_up.gif";
    }

    function handleExpand(prefix) {
        var el = parent.panelFrame.document.getElementById( prefix + '_seqBox');
        el.style.display = 'block';
        var twistie = parent.panelFrame.document.getElementById( prefix + '_twistie');
        twistie.src = "images/twistie_down.gif";
    }


    function SubNavLink( subSequenceName ){
        //Private elements
        this.name = subSequenceName;  //subsequence name
        this.returnToLinkMap = {
            set : function( grp, seqs ) { this[grp] = seqs;},
            get : function( grp ) { return this[grp];}
        }    //map return type to array [ type, target ];


        //Public functions
        this.addLink = addLink;
        this.getLink = getLink;
    }

    function addLink( retType, typeTargArray ){
        this.returnToLinkMap.set( retType, typeTargArray );
    }

    function getLink( retType ){
        return this.returnToLinkMap.get( retType );
    }
