

var isLocked = document.location + "";
isLocked = isLocked.substring( isLocked.indexOf('?')+1);
argAry = isLocked.split('&')
var tabArray = new Array("expression", "note", "rendered", "context","source", "appinfo");
function viewPanel( panel ){
    var tempWindow;
    var locked = "false";
    if( getArg("locked"))
        locked = getArg("locked");
    if( locked != "true" ){
        tempWindow = window.open(panel + ".html?true", "viewPanel", "scrollbars=yes,toolbar=yes,location=no,menubar=yes,resizable=yes");
        tempWindow.focus();
    }
}

function getArg( key ){
    for( i = 0;i < argAry.length;i++){
        var tmpAry = argAry[i].split('=');
        if( tmpAry[0].toLowerCase() == key ){
            return tmpAry[1];
            break;
        }
    }
    return null;
}


function modifyAbortLink(){
    if( isLocked == "true"){
        var abortLink = document.getElementById( "abortLink");
        abortLink.firstChild.data="Close Window";
    }
}

function locked(){
    if(isLocked == "true"){
        alert("This panel is currently in view only mode.");
        return true;
    }
    return false;
}

function printStack(){
    if( parent && parent.dataFrame ){
        parent.dataFrame.printStack();
    }
}
function abortSequence(){
    if( isLocked == "true" ){
        window.close();
    } else {
        if( parent && parent.dataFrame ){
            parent.dataFrame.abort();
        }
    }

}

function openPanel( panelId ){
    var panel = document.getElementById( panelId );
	var panelLink = document.getElementById( panelId + "_link" );	
	if( panel ){
		panel.style.display = "block";
	}	
}

function closePanel( panelId ){
	var panel = document.getElementById( panelId );	
	if( panel ){
		panel.style.display = "none";
	}
}


function togglePanel( panelId ){
	var panel = document.getElementById( panelId );
	switch ( panelId ){
		case "infoPanel":
			closePanel( "warningPanel");
			closePanel( "errorPanel");
		break;
		case "errorPanel":
			closePanel( "infoPanel");
			closePanel( "warningPanel");
		break;
		case "warningPanel":
			closePanel( "infoPanel");
			closePanel( "errorPanel");
		break;
	}
	if( !isOpen( panel ) ){				
		openPanel( panelId );
	} else {
		closePanel( panelId );
	}
	
}

function isOpen( panel ){
	if( panel )
		return !(panel.style.display == "none" || panel.style.display == "");
	return false;
}

function myOPEN( caller, panel, istask ){
    if( locked() ){
        return;
    }
    if( parent && parent.dataFrame ){
        parent.dataFrame.myOPEN(caller,panel,istask);
    }
}

function myCLOSE( caller ){
    if( locked() ){
        return;
    }
    if( parent && parent.dataFrame ){
        parent.dataFrame.myCLOSE(caller);
    }
}
function myCOMPLETE( callerSequence ){
    if( locked() ){
        return;
    }
    if( parent && parent.dataFrame ){
        parent.dataFrame.myCOMPLETE(callerSequence);
    }
}

function myBACK_COMPLETE( callerSequence ){
    if( locked() ){
        return;
    }
    if( parent && parent.dataFrame ){
        parent.dataFrame.myBACK_COMPLETE(callerSequence);
    }
}

function myREPLACE( panel ){
    if( locked() ){
        return;
    }
    if( parent && parent.dataFrame ){
        parent.dataFrame.myREPLACE(panel);
    }
}	

function noClick(){
    alert("Please use the navigation below");
}	

function mySUSPEND( panel ){
    if( locked() ){
        return;
    }
    if( parent && parent.dataFrame ){
        parent.dataFrame.mySUSPEND(panel);
    }
}

function mySUBSEQUENCE( callingSubsequence, callingPanel, targetName, isDotLast, subsequence, type ){
    if( locked() ){
        return;
    }
    if( parent && parent.dataFrame ){
        parent.dataFrame.mySUBSEQUENCE(callingSubsequence,callingPanel,targetName,isDotLast,subsequence,type);
    }
}
function myNOACTION( caller ){
    if( locked() ){
        return;
    }
    if( parent && parent.dataFrame ){
        parent.dataFrame.myNOACTION(caller);
    }
}
function aimCrossHair( ){
    if( getArg("locked") == "true" ){
        var mapAry = document.getElementsByTagName('IMG');
        for( var i = 0; i < mapAry.length; i++){
            if(mapAry[i] && mapAry[i].useMap && mapAry[i].useMap == "#psxmlflow" ){
                var parent = mapAry[i].parentNode;
                var img = mapAry[i];
                img.useMap ="";
                img.style.cursor = "default";
                var children = parent.childNodes;
                while( parent.hasChildNodes() ){
                    parent.removeChild( parent.childNodes[0]);
                }
                parent.appendChild( img );
            }
        }
        return;
    }
    var shapeArea = document.getElementById(getArg("panel"));
    if( shapeArea ){
        var shape = shapeArea.shape.toLowerCase();
        switch( shape ){
        case "rect":
            {
                var coordAry = shapeArea.coords.split(",");
                if( coordAry && coordAry.length == 4){
                    moveCrossHair( coordAry );
                    scrollToFit(coordAry);
                }
                break;
            }
        case "poly":
            {
                var leftMost = -1;
                var topMost = -1;
                var rightMost = 0;
                var bottomMost = 0;
                var finalCoord = new Array();
                var coordAry = new Array();
                //build comma delimited coords ie removes spaces
                var coords = shapeArea.coords
                while( coords.indexOf(' ') > -1 ){
                    coords = coords.replace(' ', ',');
                }
                var tempAry = coords.split(',').reverse();
                while( tempAry.length > 0 ){
                    coordAry.push( tempAry.pop() + "," + tempAry.pop() );
                }
                for(i = 0; i < coordAry.length;i++){
                    var xyArray = coordAry[i].split(",");
                    if( leftMost == -1 )
                        leftMost = parseInt(xyArray[0]);
                    if( topMost == -1 )
                        topMost = parseInt(xyArray[1]);
                    if( leftMost > parseInt(xyArray[0]))
                        leftMost = parseInt(xyArray[0]);
                    if( topMost > parseInt(xyArray[1]))
                        topMost = parseInt(xyArray[1]);
                    if( rightMost < parseInt(xyArray[0]))
                        rightMost = parseInt(xyArray[0]);
                    if( bottomMost < parseInt(xyArray[1]))
                        bottomMost = parseInt(xyArray[1]);
                }
                    finalCoord.push( leftMost );
                    finalCoord.push( topMost );
                    finalCoord.push( rightMost );
                    finalCoord.push( bottomMost );
                    moveCrossHair( finalCoord );
                    scrollToFit(finalCoord);
            }
        }
    }
}

function moveCrossHair( coordAry ){
    var sapsGraph = document.getElementById( "sapsGraph");

    var leftMost = parseInt(coordAry[0]) + parseInt(sapsGraph.offsetLeft) -10;
    var topMost = parseInt(coordAry[1]) + parseInt(sapsGraph.offsetTop)-10;
    var rightMost = 10 + parseInt(coordAry[2]) + parseInt(sapsGraph.offsetLeft)-12;
    var bottomMost = 10 + parseInt(coordAry[3])+ parseInt(sapsGraph.offsetTop)-12;


    var ltHair = document.getElementById( "lthair");
    ltHair.style.zIndex = 100;
    ltHair.style.top = topMost;
    ltHair.style.left = leftMost;
    var lbHair = document.getElementById( "lbhair");
    lbHair.style.zIndex = 100;
    lbHair.style.top = bottomMost
    lbHair.style.left = leftMost;
    var rbHair = document.getElementById( "rbhair");
    rbHair.style.zIndex = 100;
    rbHair.style.top = bottomMost
    rbHair.style.left = rightMost;
    var rtHair = document.getElementById( "rthair");
    rtHair.style.zIndex = 100;
    rtHair.style.top = topMost
    rtHair.style.left = rightMost;
}
function scrollToFit( coordAry ){
    var sapsGraph = parent.graphFrame.document.getElementById( "sapsGraph");
    var leftMost = parseInt(coordAry[0]) + parseInt(sapsGraph.offsetLeft) -10;
    var topMost = parseInt(coordAry[1]) + parseInt(sapsGraph.offsetTop)-10;
    var rightMost = 10 + parseInt(coordAry[2]) + parseInt(sapsGraph.offsetLeft)-12;
    var bottomMost = 10 + parseInt(coordAry[3])+ parseInt(sapsGraph.offsetTop)-12;
    var centerx = leftMost + (( rightMost - leftMost ) / 2);
    var centery = topMost + (( bottomMost - topMost ) / 2);
    centerx = parseInt( centerx - ( parent.graphFrame.document.body.clientWidth /2 ));
    if( centerx < 0 )
        centerx = 0;
    centery = parseInt( centery - ( parent.graphFrame.document.body.clientHeight /2 ));
    if( centery < 0 )
        centery = 0;
    parent.graphFrame.scroll( centerx, centery );
}
function noClick(){
    if( parent.dataFrame )
        alert("Please use the navigation below");
    else
        alert("This panel is currently in view only mode.");
}

function openTab( tabId ){
    var resourceDiv = document.getElementById( "resource" );
    var tabContent = document.getElementById( tabId );
    var tabDiv = document.getElementById( tabId+ "_div" );

    for( i=0;i<tabArray.length;i++){
        var t = document.getElementById( "saps_" + tabArray[i] );
        var td = document.getElementById( "saps_" + tabArray[i] + "_div" );
        if( t )
            t.style.display="none";
        if( td )
            td.style.backgroundColor="";
    }
    tabDiv.style.backgroundColor="white";
    tabContent.style.display="block";


 switch( tabId ){
        case "saps_rendered":{
            resourceDiv.style.borderColor = "#3082BF";
            resourceDiv.style.backgroundColor="white";
            resourceDiv.style.backgroundImage="url('../images/blueBackground.gif')";
            break;
        }
        case "saps_appinfo":{
            resourceDiv.style.borderColor = "#3082BF";
            resourceDiv.style.backgroundColor="white";
            resourceDiv.style.backgroundImage="url('')";
            break;
        }
        case "saps_expression":{
            resourceDiv.style.borderColor = "#3082BF";
            resourceDiv.style.backgroundColor="white";
            resourceDiv.style.backgroundImage="url('')";
            break;
        }
        case "saps_note":{
            resourceDiv.style.borderColor = "green";
            resourceDiv.style.backgroundColor="white";
            resourceDiv.style.backgroundImage="url('')";
            break;
        }
        case "saps_source":{
            resourceDiv.style.borderColor = "green";
            resourceDiv.style.backgroundColor="white";
            resourceDiv.style.backgroundImage="url('')";
            break;
        }
        case "saps_context":{
            resourceDiv.style.borderColor = "brown";
            resourceDiv.style.backgroundColor="white";
            resourceDiv.style.backgroundImage="url('')";
            break;
        }

    }

}

